#ifndef _KGR_PATCH_BSC1004419_H
#define _KGR_PATCH_BSC1004419_H

#if defined(CONFIG_X86_64)
int kgr_patch_bsc1004419_init(void);
struct page *kgr_follow_page_mask(struct vm_area_struct *vma,
	unsigned long address, unsigned int flags, unsigned int *page_mask);
long kgr__get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
		unsigned long start, unsigned long nr_pages,
		unsigned int gup_flags, struct page **pages,
		struct vm_area_struct **vmas, int *nonblocking);

#if !defined(CONFIG_XEN)
struct page *kgr_follow_trans_huge_pmd(struct vm_area_struct *vma,
	unsigned long addr, pmd_t *pmd, unsigned int flags);

#define KGR_PATCH_BSC1004419_FUNCS					\
	KGR_PATCH(follow_page_mask, kgr_follow_page_mask),		\
	KGR_PATCH(__get_user_pages, kgr__get_user_pages),		\
	/* bsc#1030467 */						\
	KGR_PATCH(follow_trans_huge_pmd, kgr_follow_trans_huge_pmd),

#else /* CONFIG_XEN */
#define KGR_PATCH_BSC1004419_FUNCS				\
	KGR_PATCH(follow_page_mask, kgr_follow_page_mask),	\
	KGR_PATCH(__get_user_pages, kgr__get_user_pages),

#endif /* CONFIG_XEN */

#else /* !CONFIG_X86_64 */
int kgr_patch_bsc1004419_init(void)
{
       return 0;
}

/* No patched functions is intentional. */
#define KGR_PATCH_BSC1004419_FUNCS

#endif /* CONFIG_X86_64 */

static inline void kgr_patch_bsc1004419_cleanup(void) {}


#endif
